<?PHP
/************************************************************************/
/* ClubChat Module for PHP Nuke ( version 1.4 )                         */
/* Copyright (c) 2001 by Sukiman Kateni (clubadmin@clubchat.com)        */
/* http://www.clubchat.com                                              */
/*                                                                      */
/* Someday, all chats will be made this way                                                             */
/*                                                                      */
/* This program is free software. You can redistribute it and/or modify */
/* it under the terms of the GNU General Public License as published by */
/* the Free Software Foundation; either version 2 of the License.       */
/************************************************************************/
global $dbhost, $dbname, $dbuname, $dbpass;

define ('DB_HOST',      $dbhost);
define ('DATABASE',     $dbname);
define ('DB_USER',      $dbuname);
define ('DB_PASSWORD',  $dbpass);

class clubchat  {
        var $classname        = "clubchat";
        var $CONN             = "";
        var $ROW              = "";
        var $RESULTS          = "";
        var $UID              = "";
        var $HOST             = DB_HOST;
        var $DB               = DATABASE;
        var $USER             = DB_USER;
        var $PASS             = DB_PASSWORD;
        var $DEBUG            = DEBUG;
        var $VERSION          = "ClubChat 1.4.1";

        /********************************************************/
        /* returns true on success!                             */
        /* used via $clubchat->connect();                       */
        /********************************************************/
        function connect() {    $user = $this->USER;
                $pass = $this->PASS;
                $host = $this->HOST;
                $db   = $this->DB;
                $conn = mysql_connect($host,$user,$pass);

                if(!$conn) {
                        $this->error("Connection to $db on $host failed.");
                        }

                $this->selectDb($this->DB,false);
                $this->CONN = $conn;
                return true;
                }

        /********************************************************/
        /* returns true on success!                             */
        /* MySQL Persistent connection                          */
        /********************************************************/
        function pconnect() {
                $user = $this->USER;
                $pass = $this->PASS;
                $host = $this->HOST;
                $db   = $this->DB;
                $pconn = mysql_pconnect($host,$user,$pass);

                if(!$pconn) {
                        $this->error("Connection to $db on $host failed.");
                        }

                $this->selectDb($this->DB,false);
                $this->CONN = $pconn;
                return true;
                }

        /********************************************************/
        /* error handling                                       */
        /********************************************************/
        function error($text) {
                $no = mysql_errno();
                $msg= mysql_error();
                echo "<font color='red'>[$text] ( $no : $msg )<BR></font>\n";
                }

        /********************************************************/
        /* Word replacement list                                                                */
        /********************************************************/
        function fetch_phrases($size) {
                global $prefix;

                $phraselist = "<select name=\"phrase\" size=\"$size\">\n";
                $sql = "select orgword, repword from $prefix"._chatreplace;
                $result   = $this->query_quiet($sql);

                while($rows = $this->fetch_array($result)) {
                        $phraselist = "$phraselist<option value=\"".$rows[0]."\">".$rows[0]." >> ".$rows[1]."</option>\n";
                        }
                $phraselist = "$phraselist</select>\n";
                return $phraselist;
                }

        /********************************************************/
        /* User aliases                                                                                 */
        /********************************************************/
        function fetch_aliases($uid,$uname,$size) {
                global $prefix;

                $niclist = "<b>"._CCALIASLABEL."</b> <select name=\"usn\" size=\"$size\">\n";
                if($size==1) {
                        $niclist = "$niclist<option value=\"$uname\">$uname</option>\n";
                        }

                $sql = "select alias from $prefix"._chatalias." where uid = $uid and status=0";
                $result   = $this->query_quiet($sql);

                while($rows = $this->fetch_array($result)) {
                        $niclist = "$niclist<option value=\"".$rows[0]."\">".$rows[0]."</option>\n";
                        }
                $niclist = "$niclist</select>\n";
                return $niclist;
                }

        /********************************************************/
        /* User privacy flag                                    */
        /********************************************************/
        function fetch_pflag($uid) {
                global $prefix;

                $sql = "select pflag from $prefix"._chatusers." where uid = $uid";
                $result   = $this->query_quiet($sql);
                list($pflag) = $this->fetch_row($result);

                return $pflag;
                }

        /********************************************************/
        /* User on brb ?                                        */
        /********************************************************/
        function fetch_userbrb($uid) {
                        global $prefix;

                        $sql = "select userstatus from $prefix"._chatusers." where uid = $uid";
                        $result   = $this->query_quiet($sql);
                        list($userstatus) = $this->fetch_row($result);

                        return $userstatus;
                        }

        function txtCleanUp($txt) {
                        /************************************************************************/
                        /* Cleans up the conversations                                                                                  */
                        /************************************************************************/
                        $txt    = str_replace("<", "&lt;", $txt);
                        $txt    = str_replace(">", "&gt;", $txt);
                        $txt    = preg_replace("/\r\n|\n\r|\n|\r/", " ", $txt);

                        $fp = $this->fetch_settings('forcepropercase');

                        # Force proper etiquette
                        if(strtolower($fp) == "y" || strtolower($fp) == "yes") {
                                $txt = ucfirst(strtolower($txt));
                                }
                return $txt;
                }

        function file_list($choice, $path, $size) {
        if (file_exists($path)) {
                        $handle=opendir($path);
                        while ($file = readdir($handle)) {
                                if ($file != "." && $file != ".." && $file != "index.html") {
                                        $imagelist[count($imagelist)] = $file;
                                        }
                                }

                        //Clean up and sort
                        closedir($handle);
                        if($imagelist != NULL)  {    sort($imagelist);               }
                        else                    {    $imagelist = 0;                 }
                        }
        else {
                        $imagelist = 0;
                        }

                $filelist = "<select name=\"image\" size=\"$size\">\n";
                $filelist = "$filelist<option value=\"none\">none</option>\n";
        if($imagelist != 0) {
                        foreach ($imagelist as $i) {
                                if($i == $choice) {
                                        $filelist = "$filelist<option value=\"$i\" selected>$i</option>";
                                        }
                                else {
                                        $filelist = "$filelist<option value=\"$i\">$i</option>";
                                        }
                                }
                        }
                $filelist = "$filelist</select>\n";
        return $filelist;
        }

        function wclose() {
                echo "<html><head><title></title></head><body onLoad=\"parent.window.close();\"></body></html>";
                }

        function noclick() {
                echo "<script type=\"text/javascript\">\n"
                        ."<!--\n"
                        ."if (window == top) top.location.href = \"index.php\";\n"

                        ."if (document.layers) {\n"
                        ."      window.captureEvents(Event.MOUSEDOWN);\n"
                        ."      window.captureEvents(Event.MOUSEUP);\n"
                        ."      document.captureEvents(Event.KEYDOWN);\n"
                        ."      }\n"
                        ."else if (document.all) {\n"
                        ."      document.onmousedown=right;\n"
                        ."      document.onmouseup=right;\n"
                        ."      document.onkeydown = right;\n"
                        ."      window.onmousedown=right;\n"
                        ."      window.onmouseup=right;\n"
                        ."      window.keydown=right;\n"
                        ."      }\n"
                        ."function right(e) {\n"
                        ."       if (navigator.appName == 'Netscape' &&\n"
                        ."                (e.which == 3 || e.which == 2 || e.which == 0))\n"
                        ."                return false;\n"
                        ."       else if (navigator.appName == 'Microsoft Internet Explorer' &&\n"
                        ."                (event.button == 2 || event.button == 3 || event.keyCode == 17 || event.keyCode == 18 || event.keyCode == 93)) {\n"
                        ."                alert(\"Welcome To ClubChat Clubs....\");\n"
                        ."                return false;\n"
                        ."                }\n"
                        ."       return true;\n"
                        ."       }\n"
                        ."//  End -->\n"
                        ."</script>\n";
                }

        /************************************************************************/
        /* Create the necessary table if it don't exists                                                */
        /************************************************************************/
        function create_table() {
                global $prefix;

                $sql = "create table if not exists $prefix"._clubchat." ("
                          ."time        timestamp(14),"
                          ."roomid      bigint(12),"
                          ."send_id     bigint(11),"
                          ."rcpt_id     bigint(11),"
                          ."sender      varchar(20),"
                          ."message     varchar(255),"
                          ."msgtype     tinyint(2) default 0 ) type = heap";

                $this->query_quiet($sql);

                $sql = "create table if not exists $prefix"._chatusers." ("
                          ."uid                 bigint(12),"
                          ."alias               varchar(20),"
                          ."usertype            tinyint(4) default 0,"
                          ."lastactivity        timestamp(14),"
                          ."userstatus          tinyint(4) default 0,"
                          ."roomid              int default 0,"
                          ."subroomid           int default 0,"
                          ."pflag                       tinyint(2) default 0,"
                          ."avatar              varchar(20) default 'innocent.gif',"
                          ."chatcount           smallint(6) default 0 ) type = heap";

                $this->query_quiet($sql);

                $sql = "create table if not exists $prefix"._chatalias." ("
                                ."uid                   bigint(11),"
                                ."alias                 varchar(20),"
                                ."created               date,"
                                ."status                tinyint(1) ) type = myisam";
                $this->query_quiet($sql);

                $sql = "create table if not exists $prefix"._chatgaglist." ("
                                                ."uid                   bigint(11),"
                                                ."alias                 varchar(20),"
                                                ."gagtext               varchar(200)) type = myisam";
                $this->query_quiet($sql);

                $sql = "create table if not exists $prefix"._chatlastpm." ("
                                                ."uid                   bigint(11),"
                                                ."towho                 varchar(100)) type = myisam";
                $this->query_quiet($sql);

                $sql = "create table if not exists $prefix"._chatrooms." ("
                                ."roomid        bigint(20),"
                                ."roomname      varchar(120),"
                                ."roomtype      smallint(6),"
                                ."roombg        varchar(30) default 'none',"
                                ."fontcolor     varchar(6) default '000000',"
                                ."fontfamily    varchar(12) default 'Verdana',"
                                ."maxusers      int default 20,"
                                ."sysmessage    varchar(6) default 'Gray',"
                                ."admmessage    varchar(6) default 'FF0000',"
                                ."prvmessage    varchar(6) default 'FF0000',"
                                ."fontsize      varchar(12) default '13px') type = myisam";
                $this->query_quiet($sql);

                $sql = "create table if not exists $prefix"._chatstuff." ("
                                ."category      varchar(20),"
                                ."idx           bigint(20),"
                                ."question      text,"
                                ."answer        text) type = myisam";
                $this->query_quiet($sql);

                $sql = "create table if not exists $prefix"._chatsettings." ("
                                ."id            varchar(20),"
                                ."value         varchar(200)) type = myisam";
                $this->query_quiet($sql);

                $sql = "create table if not exists $prefix"._chatignorelist." ("
                                ."uid                   bigint(11),"
                                ."igid                  bigint(11),"
                                ."alias                 varchar(20)) type = myisam";
                $this->query_quiet($sql);

                # Added on the 7th Nov 2001
                $sql = "create table if not exists $prefix"._chatreplace." ("
                          ."orgword     varchar(100),"
                          ."repword     varchar(100) ) type = myisam";

                $this->query_quiet($sql);
                $sql = "create table if not exists $prefix"._usersettings." ("
                          ."uid         bigint(11),"
                          ."id          varchar(10),"
                          ."value       varchar(40) ) type = myisam";
                # Added on the 7th Nov 2001

                $this->query_quiet($sql);

                $sql = "select roomid from $prefix"._chatrooms."";
                $result = $this->query_quiet($sql);
                if($this->num_rows($result) <= 0) {
                        $sql = "insert into $prefix"._chatrooms." (roomid,roomname,roomtype,roombg,fontcolor,maxusers) "
                                  ."values(0,'The Lounge',0,'none','000000',0)";
                        $this->query_quiet($sql);
                        $sql = "insert into $prefix"._chatrooms." (roomid,roomname,roomtype,roombg,fontcolor,maxusers) "
                                  ."values(1000,'',9,'none','000000',0)";
                        $this->query_quiet($sql);
                        $sql = "insert into $prefix"._chatrooms." (roomid,roomname,roomtype,roombg,fontcolor,maxusers) "
                                  ."values(1001,'',9,'none','000000',0)";
                        $this->query_quiet($sql);
                        }

                $sql = "select id from $prefix"._chatsettings."";
                $result = $this->query_quiet($sql);
                if($this->num_rows($result) < 12) {
                        $sql = "insert into $prefix"._chatsettings." (id,value) "
                                  ."values('entchatmesg','Welcome to {ROOM} {USER}')";
                        $this->query_quiet($sql);
                        $sql = "insert into $prefix"._chatsettings." (id,value) "
                                  ."values('entroommesg','{USER} whizzes into {ROOM}')";
                        $this->query_quiet($sql);
                        $sql = "insert into $prefix"._chatsettings." (id,value) "
                                  ."values('refreshrate','5000')";
                        $this->query_quiet($sql);
                        $sql = "insert into $prefix"._chatsettings." (id,value) "
                                  ."values('premesg','{USER} says')";
                        $this->query_quiet($sql);
                        $sql = "insert into $prefix"._chatsettings." (id,value) "
                                  ."values('logoffmesg','{USER} says later dude')";
                        $this->query_quiet($sql);
                        $sql = "insert into $prefix"._chatsettings." (id,value) "
                                  ."values('leaveroommesg','{USER} leaves {ROOM} and enters {NEWROOM}')";
                        $this->query_quiet($sql);
                        $sql = "insert into $prefix"._chatsettings." (id,value) "
                                  ."values('admpremesg','ADMINISTRATOR >')";
                        $this->query_quiet($sql);
                        $sql = "insert into $prefix"._chatsettings." (id,value) "
                                  ."values('idletime','15')";
                        $this->query_quiet($sql);
                        $sql = "insert into $prefix"._chatsettings." (id,value) "
                                  ."values('windowwidth','630')";
                        $this->query_quiet($sql);
                        $sql = "insert into $prefix"._chatsettings." (id,value) "
                                  ."values('windowheight','420')";
                        $this->query_quiet($sql);
                        $sql = "insert into $prefix"._chatsettings." (id,value) "
                                  ."values('mesgshown','5')";
                        $this->query_quiet($sql);
                        $sql = "insert into $prefix"._chatsettings." (id,value) "
                                  ."values('maximage','6')";
                        $this->query_quiet($sql);
                        $sql = "insert into $prefix"._chatsettings." (id,value) "
                                  ."values('userscolwidth','170')";
                        $this->query_quiet($sql);
                        $sql = "insert into $prefix"._chatsettings." (id,value) "
                                  ."values('forcepropercase','N')";
                        $this->query_quiet($sql);
                        }
                }

        /********************************************************/
        /* Chat misc settings                                                                   */
        /********************************************************/
        function fetch_settings($id) {
                global $prefix;

                $sql    = "select value from $prefix"._chatsettings." where id = '$id'";

                $result = $this->query_quiet($sql);
                $row    = $this->fetch_row($result);
                return $row[0];
                }

        /********************************************************/
        /* User settings ( Added on the 7th Nov 2001 )          */
        /********************************************************/
        function fetch_usersettings($uid,$id) {
                        global $prefix;

                        $sql    = "select value from $prefix"._usersettings." where id = '$id' and uid=$uid";
                        $result = $this->query_quiet($sql);

                        if($this->num_rows($result)<=0) {
                                return -1;
                                }
                        else {
                                $row    = $this->fetch_row($result);
                                return $row[0];
                                }
                        }

        function exitchat($uid, $sitename) {
                global $prefix;

                # The Club settings ( Logoff Message )
                ######################################################
                $logoffmesg = $this->fetch_settings('logoffmesg');

                # Who am i ??
                ######################################################
                $usn    = $this->fetch_WhoAmI($uid);
                $roomid = $this->fetch_WhereAmI($uid);

                $logoffmesg = str_replace ("{USER}", "$usn", "$logoffmesg");
                $logoffmesg = str_replace ("{ROOM}", "$sitename", "$logoffmesg");
                $logoffmesg = addslashes($logoffmesg);

                # Announce the user leaving
                #################################################
                $sql    = "insert into $prefix"._clubchat." (roomid,send_id,rcpt_id,sender,message,msgtype) "
                                 ."values ($roomid,$uid,-1,'$usn','$logoffmesg',1)";
                $this->query_quiet($sql);

                # Remove user from the chatroom
                ######################################################
                $sql    = "delete from $prefix"._chatusers." where uid=$uid";
                $this->query_quiet($sql);

                # check if it's a user defined room
                ######################################################
                $this->remuserdefineroom($uid, $roomid);

                $this->wclose();
                }

        /********************************************************/
        /* the roomname                                                                                 */
        /********************************************************/
        function fetch_roomname($roomid) {
        global $prefix;

        $sql    = "select roomname FROM $prefix"._chatrooms." where roomid=$roomid";
        $result = $this->query_quiet($sql);
        list($roomname) = $this->fetch_row($result);

        return $roomname;
        }

        /********************************************************/
        /* the roomtype                                                                                 */
        /********************************************************/
        function fetch_roomtype($roomid) {
        global $prefix;

        $sql    = "select roomtype from $prefix"._chatrooms." where roomid=$roomid";
        $result = $this->query_quiet($sql);
        list($roomtype) = $this->fetch_row($result);

        return $roomtype;
        }

        /********************************************************/
        /* remove user defined room                             */
        /********************************************************/
        function remuserdefineroom($uid, $roomid) {
                global $prefix;

        # Check what kinda room the user was in
        #################################################
                $rtype = $this->fetch_roomtype($roomid);

        if($rtype == 1 || $rtype == 2) {
                        # If it is a user defined room,
                        # how many users are there left ?
                        ###############################################
                        $sql    = "select roomid from $prefix"._chatusers." where roomid = $roomid";
                        $result = $this->query_quiet($sql);
                        $ucount = $this->num_rows($result);

                        if($ucount <= 0) {
                                $sql    = "delete from $prefix"._chatrooms." where roomid = $roomid";
                                $this->query_quiet($sql);

                                $sql    = "delete from $prefix"._clubchat." where roomid = $roomid";
                                $this->query_quiet($sql);
                                }
                        }
        }

        /********************************************************/
        /* Change rooms                                                                                 */
        /********************************************************/
        function changeroom($uid, $roomtype, $newroomid) {
                global $prefix;

        # Which room the user currently is
        #################################################
        $curroomid = $this->fetch_WhereAmI($uid);

        # Get the current room name
        #################################################
        $curroomname = $this->fetch_roomname($curroomid);

        # Get the new room name
        #################################################
        $newroomname = $this->fetch_roomname($newroomid);

        # Get the changeroom message
        #################################################
        $roommesg = $this->fetch_settings('leaveroommesg');

        # Who am i ??
        #################################################
        $usn = $this->fetch_WhoAmI($uid);

        $roommesg = str_replace ("{USER}", "$usn", "$roommesg");
        $roommesg = str_replace ("{ROOM}", "$curroomname", "$roommesg");

        if($roomtype == 2) {
                        $roommesg = str_replace ("{NEWROOM}", "PRIVATE ROOM", "$roommesg");
                        }
        else {
                        $roommesg = str_replace ("{NEWROOM}", "$newroomname", "$roommesg");
                        }

        # Announce user leaving
        #################################################
        $sql    = "insert into $prefix"._clubchat." values(null, $curroomid, $uid, -1, '$usn', '$roommesg', 1)";
        $this->query_quiet($sql);

        # Get the EnterMessage
        #################################################
        $roommesg = $this->fetch_settings('entroommesg');
        $roommesg = str_replace ("{USER}", "$usn", "$roommesg");
        $roommesg = str_replace ("{ROOM}", "$newroomname", "$roommesg");

        # Announce user entrance
        #################################################
        $sql    = "insert into $prefix"._clubchat." values(null, $newroomid, $uid, -1, '$usn', '$roommesg', 1)";
        $this->query_quiet($sql);

        # Switch user to the room
        #################################################
        $sql    = "update $prefix"._chatusers." set roomid = $newroomid where uid = $uid";
        $this->query_quiet($sql);

        # Check what kinda room the user was in
        #################################################
        $this->remuserdefineroom($uid, $curroomid);

        # update the Chatcount to clear the screen
        #################################################
        $sql    = "update $prefix"._chatusers." set chatcount = 100 where uid = $uid";
        $this->query_quiet($sql);
        }

        /********************************************************/
        /* User ignored list                                                                    */
        /********************************************************/
        function fetch_ignorelist($uid) {
                        global $prefix;

                        $sql    = "select igid, alias from $prefix"._chatignorelist." "
                                         ."where uid = $uid "
                                         ."order by alias asc";

                        $result   = $this->query_quiet($sql);
                        $ignorelist = "<select name=\"pmid\" size=\"5\">\n";
                        while($rows = $this->fetch_array($result)) {
                                $ignorelist = "$ignorelist<option value=\"".$rows[igid]."\">".$rows[alias]."</option>\n";
                                }
                        $ignorelist = "$ignorelist</select>\n";
                        return $ignorelist;
                        }

        /********************************************************/
        /* User type                                            */
        /********************************************************/
        function fetch_usertype($uid) {
                global $prefix;

                $sql    = "select alias, usertype, userstatus from $prefix"._chatusers." where uid=$uid";
                $result = $this->query_quiet($sql);
                $row    = $this->fetch_row($result);
                return $row;
                }

        /********************************************************/
        /* Trivia or riddle questions/answer                                    */
        /********************************************************/
        function fetch_qoa($idx, $cat, $qoa) {
                global $prefix;

                        if($qoa == "q") {
                                $sql    = "select question from $prefix"._chatstuff." where category='$cat' and idx = $idx";
                                }
                        else {
                                $sql    = "select answer from $prefix"._chatstuff." where category='$cat' and idx = $idx";
                                }

                        $result = $this->query_quiet($sql);
                        $row    = $this->fetch_row($result);
                        return $row[0];
                        }

        /********************************************************/
        /* Returns the roomid where the user currently is               */
        /********************************************************/
        function fetch_WhereAmI($uid) {
                global $prefix;

                $sql = "SELECT roomid FROM $prefix"._chatusers." where uid=$uid";

                $result   = $this->query_quiet($sql);
                $whereami = $this->fetch_row($result);
                return $whereami[0];
                }

        /********************************************************/
        /* Returns the nickname the user currently uses         */
        /********************************************************/
        function fetch_WhoAmI($uid) {
                global $prefix;

        $sql = "SELECT alias FROM $prefix"._chatusers." where uid=$uid";

        $result         = $this->query_quiet($sql);
        $whoami         = $this->fetch_row($result);
        return $whoami[0];
        }

        /********************************************************/
        /* Returns whether the user is still in the chatroom    */
        /* returns 0 for user is still in the room and                  */
        /*        1 if the user is no longer in the room                */
        /********************************************************/
        function fetch_stillhere($uid) {
        global $prefix;
        $sql    = "SELECT uid FROM $prefix"._chatusers." where uid = $uid";
        $result = $this->query_quiet($sql);
        $isHere = $this->num_rows($result);

        if($isHere == 1) { return 1; }
        else             { return 0; }
        }

        /********************************************************/
        /* Check if the user is ignored                         */
        /* returns 0 is user is OK ( not ignored )              */
        /*        1 if the user is ignored                      */
        /********************************************************/
        function fetch_isIgnored($uid, $tid) {
        global $prefix;

        $sql    = "select uid from $prefix"._chatignorelist." where uid = $uid and igid = $tid";
        $result = $this->query_quiet($sql);
        $junk   = $this->num_rows($result);

        return $junk;
        }

        /********************************************************/
        /* Check if the user a moderator                        */
        /********************************************************/
        function checkMod($uid) {
        $isMod = $this->fetch_usertype($uid);

        if($isMod[1] == 5 || $isMod[1] == 10) { return 1; }
        else                                  { return 0; }
        }

        /********************************************************/
        /* Check if the user is gagged                          */
        /* returns 0 is user is OK ( not gagged )               */
        /*        1 if the user is gagged                       */
        /********************************************************/
        function fetch_isGagged($uid) {
        global $prefix;

        $sql    = "select userstatus from $prefix"._chatusers." where uid=$uid";
        $result = $this->query_quiet($sql);
        list($isGagged) = $this->fetch_row($result);
        if($isGagged == 10) {   return 1;       }
        else                            {       return 0;       }
        }

        /********************************************************/
        /* Cleans up stale convos to keep the db lean and mean  */
        /********************************************************/
        function staleconvo($uid) {
                global $prefix;

        $curroomid = $this->fetch_WhereAmI($uid);

        $sql    = "select time from $prefix"._clubchat." where roomid = $curroomid order by time desc limit 15,1";
        $result = $this->query_quiet($sql);
        list($lastdate) = $this->fetch_row($result);

        if($lastdate != "") {
                        $sql    = "delete from $prefix"._clubchat." where roomid = $curroomid and time < $lastdate";
                        $this->query_quiet($sql);

                        $sql    = "delete from $prefix"._clubchat." where roomid = 256 and time < $lastdate";
                        $this->query_quiet($sql);
                        }
        }

        /********************************************************/
        /* Cleans up inactive users                                                             */
        /********************************************************/
        function staleusers() {
                global $prefix;

                $idletime = $this->fetch_settings('idletime');
                if($idletime==0) {      $idletime = 15; }

        # Check any any stale users
        ################################################
        # Delete everyone if exceed 30 minutes
        $sql = "delete from $prefix"._chatusers." where lastactivity < now() - interval 30 minute";
        $this->query_quiet($sql);

        # 15 minutes for everyone except Moderators, Founders
        # and those on brb
        ##########################################################
        $sql = "delete from $prefix"._chatusers." where userstatus = 0 and LastActivity < now() - interval $idletime minute";
        $this->query_quiet($sql);
        }

        /********************************************************/
        /* Room List                                                                                    */
        /********************************************************/
        function fetch_rooms($newroomid) {
                global $prefix;

                        $sql    = "SELECT roomid, roomname from $prefix"._chatrooms." where roomtype=0 and roomid < 1000 order by roomid asc";
                        $result   = $this->query_quiet($sql);
                        $roomlist = "<font style='color:#ff0000'><b>Rooms :</b></font> <select name=\"newroomid\">\n";
                        while($rows = $this->fetch_array($result)) {
                                if($newroomid == $rows[0]) {
                                        $roomlist = "$roomlist<option value=\"".$rows[0]."\" selected>".$rows[1]."</option>\n";
                                        }
                                else {
                                        $roomlist = "$roomlist<option value=\"".$rows[0]."\">".$rows[1]."</option>\n";
                                        }
                                }
                        $roomlist = "$roomlist</select>\n";
                        return $roomlist;
                        }

        /********************************************************/
        /* Get the list of users in the chatroom                                */
        /********************************************************/
        function fetch_allusers($uid) {
                global $prefix;

                        $sql    = "select uid,alias,roomid FROM $prefix"._chatusers." order by alias asc";
                        $result = $this->query_quiet($sql);

                        $alluserslist = "<select name=\"pmid\" size=\"5\">";
                        while($rows = $this->fetch_array($result)) {
                                $sql = "select roomname, roomtype from $prefix"._chatrooms." where roomid=".$rows["roomid"];
                                $tmpres = $this->query_quiet($sql);
                                list($room, $roomtype) = $this->fetch_row($tmpres);

                                if($roomtype == 2) {
                                        $alluserslist = "$alluserslist <option value=\"".$rows["uid"]."\">".$rows["alias"]." [PRIVATE]</option>";
                                        }
                                else {
                                        $alluserslist = "$alluserslist <option value=\"".$rows["uid"]."\">".$rows["alias"]." [$room]</option>";
                                        }
                                }
                                $alluserslist = "$alluserslist </select>";
                        return $alluserslist;
                        }

        /********************************************************/
        /* Get the list of users in the chatroom                                */
        /********************************************************/
        function fetch_UserList($uid) {
        global $prefix;

        $roomid = $this->fetch_WhereAmI($uid);

        $sql    = "SELECT uid, alias, userstatus FROM $prefix"._chatusers." where roomid=$roomid order by alias asc";
        $result = $this->query_quiet($sql);

        while($rows = $this->fetch_array($result)) {
                        $ustat = "";
                        if($rows[2] == 2) {
                                $ustat = "<span style='color:#009000'><b>(brb)</b></span>";
                                }

                        # If self, italicized name
                        ######################################################
                        if($rows[0] == $uid) {
                                $memberslist = "$memberslist <a href=\"javascript:openoptions('clubchat.php?pmid=".$rows["uid"]."&op=301&uid=$uid')\"><b><i>".$rows["alias"]."</i></b></a> $ustat<br>";
                                }
                        else {
                                $memberslist = "$memberslist <a href=\"javascript:openoptions('clubchat.php?pmid=".$rows["uid"]."&op=301&uid=$uid')\"><b>".$rows["alias"]."</b></a> $ustat<br>";
                                }
                        }
        return $memberslist;
        }

        function fetch_rand($cat,$id) {
                global $prefix;

                if($id == "") {
                        $sql    = "select idx from $prefix"._chatstuff." where category='$cat' order by rand() limit 1";
                        $result = $this->query_quiet($sql);
                        if($this->num_rows($result)<=0) {
                                $id = -1;
                                }
                        else {
                                list($id) = $this->fetch_row($result);
                                }
                        }
                else {
                        $sql    = "select idx from $prefix"._chatstuff." where category='$cat' and idx = $id";
                        $result = $this->query_quiet($sql);
                        if($this->num_rows($result)<=0) {
                                $id = -1;
                                }
                        }
                return $id;
                }

        function fetch_ans($cat,$id) {
                global $prefix;

                $sql    = "select idx from $prefix"._chatstuff." where category='$cat' and idx = $id";
                $result = $this->query_quiet($sql);
                if($this->num_rows($result)<=0) {
                        $id = -1;
                        }

                return $id;
                }

        /*function fetch_rand($cat) {
                global $prefix;

                $sql    = "select idx from $prefix"._chatstuff." where category='$cat' order by rand() limit 1";
                $result = $this->query_quiet($sql);

                list($val) = $this->fetch_row($result);
                return $val;
                }*/

        /************************************************************************/
        /* No really stats, but displays the username, room name                */
        /* number of members in the current room and total members chatting     */
        /************************************************************************/
        function fetch_Stat($uid, $curroomid) {
        global $prefix;

        $usn    = $this->fetch_WhoAmI($uid);
        $sql    = "select roomid from $prefix"._chatusers." where roomid=$curroomid";
        $result = $this->query_quiet($sql);
        $membercount = $this->num_rows($result);

        $sql    = "select roomid from $prefix"._chatusers."";
        $result = $this->query_quiet($sql);
        $totmembercount = $this->num_rows($result);

        # Get the room name and type
        ##################################################
        $sql    = "select roomname, roomtype from $prefix"._chatrooms." where roomid=$curroomid";
        $result = $this->query_quiet($sql);
        list($rname, $rtype) = $this->fetch_row($result);

        if($rtype == 1)         {   $rname = "$rname [Public]";    }
        elseif($rtype == 2)     {   $rname = "$rname [Private]";   }
        else                    {   $rname = "$rname";                             }

        return "<b>"._CCALIASLABEL."</b> $usn  &nbsp; &nbsp; <b>"._CCROOMNAMELABEL." </b> $rname &nbsp; &nbsp;  <b>Members in $rname :</b> $membercount &nbsp; &nbsp; <b>Total :</b> $totmembercount";
        }

        /********************************************************/
        /* Get the gag text                                                                             */
        /********************************************************/
        function fetch_GagText($uid) {
        global $prefix;

        $sql    = "select gagtext from $prefix"._chatgaglist." where uid = $uid";
        $result = $this->query_quiet($sql);
        list($GagText) = $this->fetch_row($result);

        return $GagText;
        }

        /********************************************************/
        /* Prepare query                                                                                */
        /********************************************************/
        function query($sql) {
                $conn           = $this->CONN;
                $results        = mysql_query($sql,$conn);

                // this way we don't have to check the results
                // in the main code for false.
                if(!$results) {
                        $this->error("Something bad happened quering the database: ");
                        }
                $this->RESULTS      = $results;
                return $results;
                }


        // doing a general query without error-checking
        function query_quiet($sql) {
                $conn       = $this->CONN;
                $results    = mysql_query($sql,$conn);
                return $results;
                }

        function selectDb($database,$err) {
                $success = @mysql_select_db($database);
                if($success) {
                        return $success;
                        }
                else {
                        if($err) {
                                $this->error("Can't select database $database");
                                }
                        }
                }

        function fetch_row($result)     {
                        $row = mysql_fetch_row($result);
                        return $row;
                        }

        function fetch_array($result)   {
                        $row = mysql_fetch_array($result,MYSQL_BOTH);
                        return $row;
                        }

        function free_result($result)   {
                        mysql_free_result($result);
                        }

        function fetch_object($result) {
                $object = mysql_fetch_object($result);
                        return $object;
        }

        function num_rows($result) {
            $num = mysql_num_rows($result);
            return $num;
                        }

        function close() {
                mysql_close($this->CONN);
                }

        function getVersion()  {
                        return $this->VERSION;
                        }

        }
return true;
?>